unit Unit1;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms,
  VCL.TMSFNCTypes, VCL.TMSFNCUtils, VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes,
  VCL.TMSFNCCustomPicker, VCL.TMSFNCColorPicker, Vcl.StdCtrls, WEBLib.StdCtrls,
  Vcl.Controls, VCL.TMSFNCCustomControl, VCL.TMSFNCCustomScrollControl,
  VCL.TMSFNCGridData, VCL.TMSFNCCustomGrid, VCL.TMSFNCGrid, VCL.TMSFNCGridCell,
  VCL.TMSFNCGridOptions, Vcl.Imaging.pngimage, WEBLib.ExtCtrls, WEBLib.Controls,
  WEBLib.CDS, Data.DB, Datasnap.DBClient, VCL.TMSFNCCustomComponent,
  VCL.TMSFNCGridDatabaseAdapter, WEBLib.DBCtrls, VCL.Graphics, WEBLib.DB;

type
  TForm4 = class(TWebForm)
    TMSFNCGrid1: TTMSFNCGrid;
    btnFilter: TWebButton;
    WebClientDataSet1: TWebClientDataSet;
    WebClientConnection1: TWebClientConnection;
    TMSFNCGridDatabaseAdapter1: TTMSFNCGridDatabaseAdapter;
    WebLabel1: TWebLabel;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    WebDBMemo1: TWebDBMemo;
    WebDBEdit1: TWebDBEdit;
    WebDBEdit2: TWebDBEdit;
    WebDBNavigator1: TWebDBNavigator;
    WebLabel4: TWebLabel;
    WebDBEdit3: TWebDBEdit;
    WebDataSource1: TWebDataSource;
    WebLabel5: TWebLabel;
    WebLabel6: TWebLabel;
    procedure WebFormCreate(Sender: TObject);
    procedure btnFilterClick(Sender: TObject);
    procedure WebClientConnection1AfterConnect(Sender: TObject);
    procedure TMSFNCGrid1GetCellLayout(Sender: TObject; ACol, ARow: Integer;
      ALayout: TTMSFNCGridCellLayout; ACellState: TTMSFNCGridCellState);
    procedure TMSFNCGrid1GetCellEditorType(Sender: TObject; ACol, ARow: Integer;
      var CellEditorType: TTMSFNCGridEditorType);
    procedure TMSFNCGrid1TopLeftChanged(Sender: TObject; ATopRow,
      ALeftCol: Integer);
  public
    filtered: boolean;
    procedure ImageCacheReady(Sender: TObject);
    procedure ForceAutoSizing;
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.btnFilterClick(Sender: TObject);
begin
  WebClientConnection1.Active := True;
  btnFilter.Enabled := false;
end;

procedure TForm4.ForceAutoSizing;
begin
  if not WebClientConnection1.Active then
    Exit;

  TMSFNCGrid1.BeginUpdate;
  TMSFNCGrid1.DefaultColumnWidth := 100;
  TMSFNCGrid1.DefaultRowHeight := 100;
  TMSFNCGrid1.AutoSizeColumns;
  TMSFNCGrid1.ColumnWidths[7] := 150;
  TMSFNCGrid1.EndUpdate;
end;

procedure TForm4.ImageCacheReady(Sender: TObject);
begin
  ForceAutoSizing;
end;

procedure TForm4.TMSFNCGrid1GetCellEditorType(Sender: TObject; ACol,
  ARow: Integer; var CellEditorType: TTMSFNCGridEditorType);
begin
  if ACol = 7 then
    CellEditorType := etMemo;
end;

procedure TForm4.TMSFNCGrid1GetCellLayout(Sender: TObject; ACol, ARow: Integer;
  ALayout: TTMSFNCGridCellLayout; ACellState: TTMSFNCGridCellState);
begin
  if ACol = 7 then
  begin
    ALayout.WordWrapping := True;
    if (ARow > 0) then
      ALayout.VerticalTextAlign := gtaLeading;
  end;
end;

procedure TForm4.TMSFNCGrid1TopLeftChanged(Sender: TObject; ATopRow,
  ALeftCol: Integer);
begin
  ForceAutoSizing;
end;

procedure TForm4.WebClientConnection1AfterConnect(Sender: TObject);
begin
  TMSFNCGridDatabaseAdapter1.Active := True;
  TMSFNCGridDatabaseAdapter1.Columns[7].PictureField := True;
end;

procedure TForm4.WebFormCreate(Sender: TObject);
var
  f: TFieldDef;
begin
  WebClientConnection1.URI := 'https://download.tmssoftware.com/tmsweb/fishfacti2.json';
  WebClientConnection1.DataNode := 'ROW';
  WebClientDataSet1.FieldDefs.Clear;
  WebClientDataSet1.FieldDefs.Add('_Species_No',ftString,0);
  WebClientDataSet1.FieldDefs.Add('_Category',ftstring,50);
  WebClientDataSet1.FieldDefs.Add('_Common_Name',ftstring,50);
  WebClientDataSet1.FieldDefs.Add('_Species_Name',ftstring,50);
  WebClientDataSet1.FieldDefs.Add('_Length__cm_',ftInteger,0);
  WebClientDataSet1.FieldDefs.Add('_Length_In',ftString,30);
  WebClientDataSet1.FieldDefs.Add('_Notes',ftString,255);
  f := WebClientDataSet1.FieldDefs.AddFieldDef;
  f.Name := '_Graphic';
  f.DataType := ftString;
  f.Size := 255;
  f.Attributes := [faReadonly];

  TMSFNCGrid1.UseColumns := False;
  TMSFNCGrid1.Appearance.FixedLayout.Font.Size := 10;
  TMSFNCGrid1.Appearance.FixedLayout.Font.Style := [fsBold];

  Application.OnImageCacheReady := ImageCacheReady;
end;

end.
